# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`realmd`](#realmd): realmd
* [`realmd::config`](#realmd--config): == Class realmd::config  This class is called from realmd for service config.
* [`realmd::install`](#realmd--install): == Class realmd::install  This class is called from realmd for install.
* [`realmd::join`](#realmd--join): == Class realmd::join  This class is called from realmd for joining AD.
* [`realmd::join::keytab`](#realmd--join--keytab): == Class realmd::join::keytab  This class is called from realmd for performing a passwordless AD join with a Kerberos keytab
* [`realmd::join::one_time_password`](#realmd--join--one_time_password): == Class realmd::join::password  This class is called from realmd for joining AD using a username and password. The default password for Wind
* [`realmd::join::password`](#realmd--join--password): == Class realmd::join::password  This class is called from realmd for joining AD using a username and password.
* [`realmd::sssd::config`](#realmd--sssd--config): == Class realmd::sssd::config  This class is called from realmd for SSSD service configuration.
* [`realmd::sssd::service`](#realmd--sssd--service): == Class realmd::sssd::service  This class is meant to be called from realmd. It ensure the service is running.

## Classes

### <a name="realmd"></a>`realmd`

Installs, configures, and joins a domain using realmd.
Optionally control the Kerberos client and SSSD configuration files and the SSSD service.

Default values for all parameters are in hiera.

#### Parameters

The following parameters are available in the `realmd` class:

* [`realmd_package_name`](#-realmd--realmd_package_name)
* [`realmd_package_ensure`](#-realmd--realmd_package_ensure)
* [`realmd_config_file`](#-realmd--realmd_config_file)
* [`realmd_config`](#-realmd--realmd_config)
* [`homedir_umask`](#-realmd--homedir_umask)
* [`adcli_package_name`](#-realmd--adcli_package_name)
* [`adcli_package_ensure`](#-realmd--adcli_package_ensure)
* [`krb_client_package_name`](#-realmd--krb_client_package_name)
* [`krb_client_package_ensure`](#-realmd--krb_client_package_ensure)
* [`sssd_package_name`](#-realmd--sssd_package_name)
* [`sssd_package_ensure`](#-realmd--sssd_package_ensure)
* [`sssd_service_name`](#-realmd--sssd_service_name)
* [`sssd_service_ensure`](#-realmd--sssd_service_ensure)
* [`sssd_config_file`](#-realmd--sssd_config_file)
* [`sssd_config_cache_file`](#-realmd--sssd_config_cache_file)
* [`sssd_config`](#-realmd--sssd_config)
* [`manage_sssd_config`](#-realmd--manage_sssd_config)
* [`manage_sssd_service`](#-realmd--manage_sssd_service)
* [`manage_sssd_package`](#-realmd--manage_sssd_package)
* [`domain`](#-realmd--domain)
* [`netbiosname`](#-realmd--netbiosname)
* [`domain_join_user`](#-realmd--domain_join_user)
* [`domain_join_password`](#-realmd--domain_join_password)
* [`one_time_password`](#-realmd--one_time_password)
* [`krb_ticket_join`](#-realmd--krb_ticket_join)
* [`krb_keytab`](#-realmd--krb_keytab)
* [`krb_config_file`](#-realmd--krb_config_file)
* [`krb_config`](#-realmd--krb_config)
* [`manage_krb_config`](#-realmd--manage_krb_config)
* [`ou`](#-realmd--ou)
* [`required_packages`](#-realmd--required_packages)
* [`extra_join_options`](#-realmd--extra_join_options)
* [`computer_name`](#-realmd--computer_name)

##### <a name="-realmd--realmd_package_name"></a>`realmd_package_name`

Data type: `String`

The name of the main Realmd package

##### <a name="-realmd--realmd_package_ensure"></a>`realmd_package_ensure`

Data type: `String`



##### <a name="-realmd--realmd_config_file"></a>`realmd_config_file`

Data type: `Stdlib::Absolutepath`

The absolute path of the Realmd configuration file

##### <a name="-realmd--realmd_config"></a>`realmd_config`

Data type: `Hash`

A hash of configuration options structured in an ini-style format

##### <a name="-realmd--homedir_umask"></a>`homedir_umask`

Data type: `String`

A string of the umask for the default directory permissions created by mkhomedir with Debian

##### <a name="-realmd--adcli_package_name"></a>`adcli_package_name`

Data type: `String`

The name of the adcli package

##### <a name="-realmd--adcli_package_ensure"></a>`adcli_package_ensure`

Data type: `String`



##### <a name="-realmd--krb_client_package_name"></a>`krb_client_package_name`

Data type: `String`

The name of the Kerberos client package

##### <a name="-realmd--krb_client_package_ensure"></a>`krb_client_package_ensure`

Data type: `String`



##### <a name="-realmd--sssd_package_name"></a>`sssd_package_name`

Data type: `String`

The name of the main SSSD package

##### <a name="-realmd--sssd_package_ensure"></a>`sssd_package_ensure`

Data type: `String`



##### <a name="-realmd--sssd_service_name"></a>`sssd_service_name`

Data type: `String`

The name of the SSSD service

##### <a name="-realmd--sssd_service_ensure"></a>`sssd_service_ensure`

Data type: `String`



##### <a name="-realmd--sssd_config_file"></a>`sssd_config_file`

Data type: `Stdlib::Absolutepath`

The absolute path of the SSSD configuration file

##### <a name="-realmd--sssd_config_cache_file"></a>`sssd_config_cache_file`

Data type: `Stdlib::Absolutepath`



##### <a name="-realmd--sssd_config"></a>`sssd_config`

Data type: `Hash`

A hash of configuration options structured in an ini-style format

##### <a name="-realmd--manage_sssd_config"></a>`manage_sssd_config`

Data type: `Boolean`

Enable or disable management of the SSSD configuration file

##### <a name="-realmd--manage_sssd_service"></a>`manage_sssd_service`

Data type: `Boolean`

Enable or disable management of the SSSD service

##### <a name="-realmd--manage_sssd_package"></a>`manage_sssd_package`

Data type: `Boolean`



##### <a name="-realmd--domain"></a>`domain`

Data type: `String`

The name of the domain to join

##### <a name="-realmd--netbiosname"></a>`netbiosname`

Data type: `String`

The computer name used with one-time-password (computer account) join

##### <a name="-realmd--domain_join_user"></a>`domain_join_user`

Data type: `Variant[String, Undef]`

The account to be used in joining the domain

##### <a name="-realmd--domain_join_password"></a>`domain_join_password`

Data type: `Variant[String, Undef]`

The password of the account to be used in joining the domain

##### <a name="-realmd--one_time_password"></a>`one_time_password`

Data type: `Variant[String, Undef]`

The password of the prepared computer account

##### <a name="-realmd--krb_ticket_join"></a>`krb_ticket_join`

Data type: `Boolean`

Enable of disable joining the domain via a Kerberos keytab

##### <a name="-realmd--krb_keytab"></a>`krb_keytab`

Data type: `Variant[Stdlib::Absolutepath, Undef]`

The absolute path to the Kerberos keytab file to be used in joining the domain

##### <a name="-realmd--krb_config_file"></a>`krb_config_file`

Data type: `Stdlib::Absolutepath`

The absolute path to the Kerberos client configuration file

##### <a name="-realmd--krb_config"></a>`krb_config`

Data type: `Hash`

A hash of configuration options structured in an ini-style format

##### <a name="-realmd--manage_krb_config"></a>`manage_krb_config`

Data type: `Boolean`

Enable or disable management of the Kerberos client configuration file

##### <a name="-realmd--ou"></a>`ou`

Data type: `Variant[String, Undef]`

The computer organizational unit

##### <a name="-realmd--required_packages"></a>`required_packages`

Data type: `Hash`

A hash of package resources to manage for any auxilliary functionality

##### <a name="-realmd--extra_join_options"></a>`extra_join_options`

Data type: `Variant[Array, Undef]`

Extra arguments passed to realm join command

##### <a name="-realmd--computer_name"></a>`computer_name`

Data type: `Variant[String[1, 15], Undef, Boolean[false]]`

The computer name used with password join

### <a name="realmd--config"></a>`realmd::config`

== Class realmd::config

This class is called from realmd for service config.

### <a name="realmd--install"></a>`realmd::install`

== Class realmd::install

This class is called from realmd for install.

### <a name="realmd--join"></a>`realmd::join`

== Class realmd::join

This class is called from realmd for joining AD.

### <a name="realmd--join--keytab"></a>`realmd::join::keytab`

== Class realmd::join::keytab

This class is called from realmd for performing
a passwordless AD join with a Kerberos keytab

### <a name="realmd--join--one_time_password"></a>`realmd::join::one_time_password`

== Class realmd::join::password

This class is called from realmd for
joining AD using a username and password.
The default password for Windows ADS is
"the first 15 chars of the hostname in lowercase"

### <a name="realmd--join--password"></a>`realmd::join::password`

== Class realmd::join::password

This class is called from realmd for
joining AD using a username and password.

### <a name="realmd--sssd--config"></a>`realmd::sssd::config`

== Class realmd::sssd::config

This class is called from realmd for SSSD service configuration.

### <a name="realmd--sssd--service"></a>`realmd::sssd::service`

== Class realmd::sssd::service

This class is meant to be called from realmd.
It ensure the service is running.

